﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
Sub Class_Globals
	Private ImageView1 As B4XView
	Private xui As XUI
	Private Pane1 As B4XView
	Private cvs As B4XCanvas
	Private FractalRect, SelectionRect As B4XRect
	Private sx, sy As Int
	Private bc As BitmapCreator
	Private stack As List
	Private const MAX_ITERATIONS As Int = 70
	Private scale As Float
	#if Not (B4J)
	Type MouseEvent (X As Int, Y As Int)
	Private DummyPanel As Panel 'ignore
	#End If
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	cvs.Initialize(Pane1)
	FractalRect.Initialize(-1.5, -1, 0.5, 1) 'ignore
	scale = 100dip / 100
	bc.Initialize(ImageView1.Width / scale, ImageView1.Height / scale)
	stack.Initialize
	ImageView1.SetBitmap(CreateMandelbrotFractal)
End Sub

#if Not(B4J)
Sub Pane1_Touch (Action As Int, X As Float, Y As Float)
	Dim ev As MouseEvent
	ev.X = X 
	ev.Y = Y
	If Action = DummyPanel.ACTION_DOWN Then
		Pane1_MousePressed(ev)
	Else if Action = DummyPanel.ACTION_MOVE Then
		Pane1_MouseDragged(ev)
	Else
		Pane1_MouseReleased(ev)
	End If
End Sub
#End If

Sub Pane1_MousePressed (EventData As MouseEvent)
	cvs.ClearRect(cvs.TargetRect)
	sx = EventData.X
	sy = EventData.Y
	cvs.Invalidate
End Sub

Sub Pane1_MouseDragged (EventData As MouseEvent)
	cvs.ClearRect(cvs.TargetRect)
	Dim left As Float = Min(EventData.X, sx)
	Dim top As Float = Min(EventData.Y, sy)
	Dim right As Float = Max(EventData.X, sx)
	Dim bottom As Float = Max(EventData.Y, sy)
	SelectionRect.Initialize(left, top, right, bottom)
	cvs.DrawRect(SelectionRect, xui.Color_Green, False, 2dip)
	cvs.Invalidate
End Sub

Sub Pane1_MouseReleased (EventData As MouseEvent)
	cvs.ClearRect(cvs.TargetRect)
	cvs.Invalidate
	Dim left As Float = FractalRect.Left + SelectionRect.Left / scale / bc.mWidth * FractalRect.Width
	Dim right As Float = FractalRect.Left + SelectionRect.Right / scale / bc.mWidth * FractalRect.Width
	Dim top As Float = FractalRect.Top + SelectionRect.Top / scale / bc.mHeight * FractalRect.Height
	Dim bottom As Float = FractalRect.Top + SelectionRect.Bottom / scale / bc.mHeight * FractalRect.Height
	FractalRect.Initialize(left, top, right, bottom)
	ImageView1.SetBitmap(CreateMandelbrotFractal)
End Sub

Sub btnBack_Click
	If stack.Size > 1 Then
		FractalRect = stack.Get(stack.Size - 2)
		stack.RemoveAt(stack.Size - 1)
		stack.RemoveAt(stack.Size - 1)
		ImageView1.SetBitmap(CreateMandelbrotFractal)
	End If
End Sub

Sub CreateMandelbrotFractal As B4XBitmap
	Dim r As B4XRect
	r.Initialize(FractalRect.Left, FractalRect.Top, FractalRect.Right, FractalRect.Bottom)
	stack.Add(r)
	Dim w As Int = bc.mWidth
	Dim h As Int = bc.mHeight
	Dim tx = FractalRect.Width, ty = FractalRect.Height As Double
	bc.FillRect(xui.Color_Green, bc.TargetRect)
	For row = 0 To h - 1
		For col = 0 To w - 1
			Dim real As Double = col / w * tx + FractalRect.Left
			Dim img As Double = row / h * ty + FractalRect.Top
			Dim x = 0, y = 0 As Double
			Dim iterations As Int
			Do While x * x + y * y < 4 And iterations < MAX_ITERATIONS
				Dim x_new As Double = x * x - y * y + real
				y = 2 * x * y + img
				x = x_new
				iterations = iterations + 1
			Loop
			If iterations < MAX_ITERATIONS Then
				bc.SetHSV(col, row, 255, iterations / MAX_ITERATIONS * 360, 1, iterations / (iterations + 8))
			Else
				bc.SetColor(col, row, xui.Color_Black)
			End If
		Next
	Next
	Return bc.Bitmap
End Sub




